import { PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "xbsj-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "xbsj-xe2/dist-node/xe2-utils";
import { PropertyTracker } from "../MiscObjects";
import { ESSceneObject } from "../ESSceneObject";
export declare class GeoPathTracker extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
        pathId: string;
        targetObjId: string;
        usePosition: boolean;
        useRotation: boolean;
        targetPositionPropertyName: string;
        targetRotationPropertyName: string;
        positionDebug: boolean;
        rotationDebug: boolean;
        positionEvalFuncStr: string;
        rotationEvalFuncStr: string;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _positionTracker;
    get positionTracker(): PropertyTracker;
    private _rotationTracker;
    get rotationTracker(): PropertyTracker;
    static defaultPositionEvalFuncStr: string;
    static positionEvalFuncStrReadMe: string;
    static defaultRotationEvalFuncStr: string;
    static rotationEvalFuncStrReadMe: string;
    /**
     * 强制执行
     */
    forceExecute(): void;
    constructor(id?: SceneObjectKey);
    getProperties(language?: string): import("../ESSceneObject").Property[];
}
export declare namespace GeoPathTracker {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
        pathId: string;
        targetObjId: string;
        usePosition: boolean;
        useRotation: boolean;
        targetPositionPropertyName: string;
        targetRotationPropertyName: string;
        positionDebug: boolean;
        rotationDebug: boolean;
        positionEvalFuncStr: string;
        rotationEvalFuncStr: string;
    };
}
export interface GeoPathTracker extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof GeoPathTracker.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof GeoPathTracker.createDefaultProps> & {
    type: string;
}>;
export {};
