import { ESSceneObject, PickedInfo, Player } from "xbsj-xe2/dist-node/xe2-base-objects";
import { Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "xbsj-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "xbsj-xe2/dist-node/xe2-utils";
import { XbsjPositionCallbackResultType } from "xbsj-renderer/dist-node/xr-cesium/XbsjPolyline/xbsjCreateODLinesPrimitive";
export declare type STCRoutPathBaseType = {
    startTime?: number;
    transmissionTime?: number;
    repeat?: number;
    color?: [number, number, number, number];
    bgColor?: [number, number, number, number];
    bidirectional?: 0 | 1 | 2 | 3;
    extra?: any;
};
export declare type STCRoutePathType = ({
    positions: ([number, number] | [number, number, number])[];
    width: number;
} | {
    startPos: [number, number, number];
    endPos: [number, number, number];
    heightRatio: number;
    width: number;
}) & STCRoutPathBaseType;
export declare const whiteGradientImageBase64 = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAEAAAAABCAYAAABubagXAAAATUlEQVQYlaXLOQqEUBQF0SMmojgvpfe/JiccEvlNwwuM24IK7oXKUkof7ylQoUGHHsPDMf4WNcpociTcuHBgx4oFczg9/O0tPKP7D3wBky8UMt76XnoAAAAASUVORK5CYII=";
export declare type CzmSignalTransmissionCollectionRoutePathCallbackType = (result: XbsjPositionCallbackResultType, sceneObject: CzmSignalTransmissionCollection, instanceIndex: number, frameState: Cesium.FrameState | undefined) => XbsjPositionCallbackResultType | undefined;
export declare class CzmSignalTransmissionCollection extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean;
        imageUrl: string | undefined;
        repeat: number;
        bidirectional: 0 | 1 | 2 | 3;
        startTime: number;
        transmissionTime: number | undefined;
        color: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        bgColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        width: number;
        repeatLength: number;
        arcType: "NONE" | "GEODESIC" | "RHUMB";
        brightening: boolean;
        depthTest: boolean;
        positionsSet: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number][][] | undefined>;
        data: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<STCRoutePathType[] | undefined>;
        geoJsonUrl: string;
        allowPicking: boolean;
        routePathCallbackStr: string;
        loop: boolean | undefined;
        currentTime: number | undefined;
        duration: number | undefined;
        speed: number | undefined;
        playing: boolean | undefined;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _player;
    get player(): Player;
    get ratio(): number;
    set ratio(value: number);
    get ratioChanged(): Listener<[number, number]>;
    private _finalImageUrlReact;
    get finalImageUrlReact(): import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string | undefined>;
    private _routePaths;
    get routePaths(): STCRoutePathType[] | undefined;
    set routePaths(value: STCRoutePathType[] | undefined);
    get routePathsChanged(): Listener<[STCRoutePathType[] | undefined, STCRoutePathType[] | undefined]>;
    static whiteGradientImageBase64: string;
    routePathCallback?: CzmSignalTransmissionCollectionRoutePathCallbackType;
    static defaultRoutePathCallback: (result: XbsjPositionCallbackResultType, sceneObject: CzmSignalTransmissionCollection, instanceIndex: number, frameState: Cesium.FrameState | undefined) => XbsjPositionCallbackResultType;
    static routePathCallbackStrMd: string;
    constructor(id?: SceneObjectKey);
    static defaults: {
        loop: boolean;
        startTime: number;
        currentTime: number;
        playerCurrentTime: number;
        duration: number;
        speed: number;
        playing: boolean;
        transmissionTime: number;
        viewerTagsEnums: [string, string][];
    };
    static defaultImageUri: string;
    getProperties(language?: string): import("xbsj-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmSignalTransmissionCollection {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean;
        imageUrl: string | undefined;
        repeat: number;
        bidirectional: 0 | 1 | 2 | 3;
        startTime: number;
        transmissionTime: number | undefined;
        color: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        bgColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        width: number;
        repeatLength: number;
        arcType: "NONE" | "GEODESIC" | "RHUMB";
        brightening: boolean;
        depthTest: boolean;
        positionsSet: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number][][] | undefined>;
        data: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<STCRoutePathType[] | undefined>;
        geoJsonUrl: string;
        allowPicking: boolean;
        routePathCallbackStr: string;
        loop: boolean | undefined;
        currentTime: number | undefined;
        duration: number | undefined;
        speed: number | undefined;
        playing: boolean | undefined;
    };
}
export interface CzmSignalTransmissionCollection extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmSignalTransmissionCollection.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmSignalTransmissionCollection.createDefaultProps> & {
    type: string;
}>;
export {};
