export declare type UeEventsType = {
    click: {
        et: 'click';
        eid: string;
        screenPosition: [number, number];
    };
    dbclick: {
        et: 'dbclick';
        eid: string;
        screenPosition: [number, number];
    };
    propChanged: {
        et: 'propChanged';
        eid: string;
        objId: string;
        props: {
            [k: string]: any;
        };
    };
    widgetEvent: {
        et: 'widgetEvent';
        eid: string;
        objId: string;
        type: "leftClick" | "rightClick" | "mouseEnter" | "mouseLeave" | "childMouseLeave" | "childMouseEnter";
        add?: {
            children?: string[];
            mousePos?: [number, number];
        };
    };
    hoverEvent: {
        et: "hoverEvent";
        eid: string;
        screenPosition: [number, number];
    };
    hoverOutEvent: {
        et: "hoverOutEvent";
        eid: string;
        screenPosition?: [number, number];
    };
    mouseMoveEvent: {
        et: "mouseMoveEvent";
        eid: string;
        screenPosition: [number, number];
    };
    speechRecognition: {
        "et": "speechRecognition";
        "eid": string;
        "result": string;
        "error": string;
    };
    customMessage: {
        "et": "customMessage";
        "eid": string;
        "message": string;
    };
    statusUpdate: {
        et: "statusUpdate";
        eid: string;
        result: {
            FPS: number;
            Length: number;
            Position: [number, number, number];
            Rotation: [number, number, number];
        };
        error: string;
    };
};
